﻿Version=6.90
NumberOfForms=0
NumberOfObjects=0
Sub designer
end sub
@EndOfDesignText@
' ------------------------------------------------------------
' Module naam           : xHtml
' Last modification date: 14 okt 2010
' Module doel           : Converting wiki syntax to html
' ------------------------------------------------------------
Sub Globals
	'Declare the global variables here.
	Dim arrInput(1000) As String
	Dim arrOutput(1000) As String
	Dim ColumnValue(9) As String
	Dim Totals(9)
	Dim Digits(9)
	Dim A, B, C, D, E, F, G, H, CalculationResult
	MaxColumns = 0
	TotalOutput = 0
	HtmlData = ""
	AddLineFeedToData = False
	CurrentLineIsTabHeader = True
	AddTableEnd = False
	ProcessingTable = False
	TableHasCalculations = False
	AddListEnd = False
	ProcessingList = False
End Sub

Public Sub ConvertFileToHtml(strTextFile,strHtmlFile)
	Dim c1,c2,tmpRecord
	Dim DataRead

	HtmlData               = ""
	TotalOutput            = 0
	
	AddLineFeedToData      = False
	CurrentLineIsTabHeader = True

	ProcessingTable        = False
	AddTableEnd            = False
	TableHasCalculations   = False

	ProcessingList         = False
	AddListEnd             = False

	' If the file to convert is the same as the html file, dont convert
	If strTextFile = strHtmlFile Then Return
	
	' If the file does not exists, create an empty file
	If FileExist(strTextFile) = False Then 
		FileOpen(c2,strTextFile,cWrite,cAppend)
		FileWrite(c2,"New created file.")
		FileClose(c2)
	End If
	
	' Delete the temprorary html file
	If FileExist(strHtmlFile) Then FileDel(strHtmlFile)
	
	' Open and Read the data from the file to convert
	FileOpen(c1,strTextFile,cRead)
	
	AddOutput("<HEAD>")

	' When the wikistyle.css file is found, add the reference to the html
	If FileExist(Main.Root&"\wikistyle.css") Then
		AddOutput("<link rel="&Chr(34)&"stylesheet"&Chr(34)&" href="&Chr(34)&Main.Root&"\wikistyle.css"&Chr(34)&" type="&Chr(34)&"text/css"&Chr(34)&" />")
	End If

	AddOutput("</HEAD>")

	' Start with the HTML and BODy tags
	AddOutput("<HTML>")
	AddOutput("<BODY>")

	Do
		DataRead=FileRead(c1)
		If DataRead<>EOF Then
			HtmlData = DataRead
			AddLineFeedToData = True
			
			ConvertHeaders		'Make headers
			ConvertTables		'Create tables
			ConvertLists		'Create bulleted lists
			ConvertLines		'Draw a single line
			
			'Convert the double characters to maken them unique to keep them without markup
			HtmlData = StrReplace(HtmlData,"**","&doublestar;")
			HtmlData = StrReplace(HtmlData,"--","&minus;")
			HtmlData = StrReplace(HtmlData,"==","&doubleis;")
			HtmlData = StrReplace(HtmlData,"__","&doubleunder;")
			
			HtmlData = StrReplace(HtmlData,"~","&nbsp;&nbsp;&nbsp;&nbsp;")
			
			ConvertImages		'Images

			ConvertSimpleTag("*","B")		'Bold text
			ConvertSimpleTag("=","I")		'Italic text
			ConvertSimpleTag("_","U")		'Undelined text
			
			ConvertDoubleTag("[{","}]","code")	'Code without markup
			
			ConvertHyperlinks	'URL Hyperlinks

			'Add newline when the boolean is true
			If AddLineFeedToData Then HtmlData = HtmlData&"<br />"

			'End the list when no new list-item is entered or the boolean is true
			If SubString(HtmlData,0,4)<>"<li>" AND AddListEnd Then
				AddOutput("</ul>")
				AddListEnd = False
			End If
			
			'End the table when no new table-row is entered or the boolean is true
			If SubString(HtmlData,0,4)<>"<tr>" AND (AddTableEnd OR ProcessingTable) Then
				If TableHasCalculations Then AddTablesResultRecord
				AddOutput("</table>")
				AddTableEnd = False
				ProcessingTable = False
			End If
			
			'Convert the unique values back to a single character without markup
			HtmlData = StrReplace(HtmlData,"&doubleunder;","_")
			HtmlData = StrReplace(HtmlData,"&doubleminus;","-")
			HtmlData = StrReplace(HtmlData,"&doubleis;","=")
			HtmlData = StrReplace(HtmlData,"&doublestar;","*")

			'Convert the unique values back to a single character without markup, used in
			'links and filenames
			HtmlData = StrReplace(HtmlData,"&savedspace;"," ")
			HtmlData = StrReplace(HtmlData,"&savedminus;","-")
			HtmlData = StrReplace(HtmlData,"&savedunder;","_")

			AddOutput(HtmlData)
		End If
	Loop Until DataRead=EOF
	FileClose(c1)
	
	'End the list when one of the booleans is true
	If AddListEnd OR ProcessingList Then
		AddOutput("</ul>")
		AddListEnd = False
	End If
	
	'End the table one of the booleans is true
	If AddTableEnd OR ProcessingTable Then
		If TableHasCalculations Then AddTablesResultRecord
		AddOutput("</table>")
		AddTableEnd = False
		ProcessingTable = False
	End If
	
	' Finish with the HTML and BODY tags
	AddOutput("</BODY>")
	AddOutput("</HTML>")

	'Write the output array to the file
	FileOpen(c2,strHtmlFile,cWrite,cAppend)
	For I = 1 To TotalOutput Step 1
		FileWrite(c2,arrOutput(I))
	Next I
	FileClose(c2)
End Sub

'Add a string to the output array
Public Sub AddOutput(newString)
	TotalOutput = TotalOutput + 1
	arrOutput(TotalOutput) = newString
End Sub

'Remove the added linefeed from the array number given
Public Sub RemoveLineFeed(arrayNumber)
	Dim Len As Integer, Str As String
	If TotalOutput <= 1 Then Return
	Str = arrOutput(arrayNumber)
	Len = StrLength(Str)
	If Len=>6 Then
		If SubString(Str,Len-6,6)="<br />" Then
			Str                    = SubString(Str,0,Len-6)
			arrOutput(arrayNumber) = Str
		End If
	End If
End Sub

'Create a heading
Public Sub ConvertHeaders
	For I = 6 To 1 Step -1
		If SubString(HtmlData,0,I)=SubString("++++++",0,I) Then
			HtmlData          = StrRemove(HtmlData,0,I)
			HtmlData          = "<h"&I&">"&HtmlData&"</h"&I&">"
			AddLineFeedToData = False
			Exit
		End If
	Next I
End Sub

Public Sub NoMarkup(StartPos,EndPos)
	PosStartCode = StrIndexOf(HtmlData,"<code>" ,StartPos)
	If PosStartCode = -1 Then PosStartCode = StrIndexOf(HtmlData,"[{" ,StartPos)
	PosEndCode = StrIndexOf(HtmlData,"</code>",PosStartCode+2)
	If PosEndCode = -1 Then PosEndCode = StrIndexOf(HtmlData,"}]",PosStartCode+2)
	If PosStartCode = -1 Then PosStartCode=9999
	If PosEndCode   = -1 Then PosEndCode=0
	If (StartPos>PosEndCode+2 OR EndPos<PosStartCode ) Then
		Return False
	Else
		Return True
	End If
End Sub

'Convet an immage link into areal image
Public Sub ConvertImages
	Dim PosStartBracket, PosEndBracket, PosSearchStart, ImageText, FullLinkLength
	PosSearchStart = 0
ErrorLabel(ConvertImages_ERROR)
	Do
		PosStartBracket = StrIndexOf(HtmlData,"[$",PosSearchStart)
		If PosStartBracket >= 0 Then
			PosEndBracket = StrIndexOf(HtmlData,"$]",PosStartBracket+2)
			If PosEndBracket >= PosStartBracket+2 Then
				If NoMarkup(PosSearchStart,PosEndBracket) = False Then
					FullLinkLength = PosEndBracket-PosStartBracket+2
					ImageText      = SubString(HtmlData,PosStartBracket+2,PosEndBracket-PosStartBracket-2)
					ImageText      = StrReplace(ImageText," ","&savedspace;")
					ImageText      = StrReplace(ImageText,"_","&savedunder;")
					ImageText      = StrReplace(ImageText,"-","&savedminus;")
					HtmlData       = StrRemove(HtmlData,PosStartBracket,FullLinkLength)
					HtmlData       = StrInsert(HtmlData,PosStartBracket,"<img src="&Chr(34)&Main.Root&"\Images\"&ImageText&Chr(34)&"/>")
				End If
				PosSearchStart = PosEndBracket+2
			Else
				PosStartBracket = -1
			End If
		End If
	Loop Until PosStartBracket = -1
	Return
ConvertImages_ERROR:
End Sub

'Convert a hyperlink in the correct html format
Public Sub ConvertHyperlinks
	Dim PosStartBracket, PosEndBracket, PosMiddleBrackets, PosStartCode, PosEndCode, PosSearchStart, LinkPage, LinkText, FullLinkLength, Link
	PosSearchStart = 0
ErrorLabel(ConvertHyperlinks_ERROR1)
	Do
		PosStartBracket = StrIndexOf(HtmlData,"[[",PosSearchStart)
		If PosStartBracket >= 0 Then
			PosEndBracket = StrIndexOf(HtmlData,"]]",PosStartBracket+2)
			If PosEndBracket >= PosStartBracket+1 Then
				If NoMarkup(PosSearchStart,PosEndBracket) = False Then
					PosMiddleBrackets = StrIndexOf(HtmlData,"][",PosStartBracket+2)
					FullLinkLength    = PosEndBracket-PosStartBracket+2
					LinkPage          = SubString(HtmlData,PosStartBracket+2,PosMiddleBrackets-PosStartBracket-2)
					LinkText          = SubString(HtmlData,PosMiddleBrackets+2,PosEndBracket-PosMiddleBrackets-2)
					If SubString(LinkPage,0,4)<>"http" Then
						Link = Main.Root&"\"&LinkPage&".txt"
					Else
						Link = LinkPage
					End If
					Link     = StrReplace(Link," ","&savedspace;")
					Link     = StrReplace(Link,"_","&savedunder;")
					Link     = StrReplace(Link,"-","&savedminus;")
					HtmlData = StrRemove(HtmlData,PosStartBracket,FullLinkLength)
					HtmlData = StrInsert(HtmlData,PosStartBracket,"<a href="&Chr(34)&Link&Chr(34)&">"&LinkText&"</a>")
				End If
				PosSearchStart = PosEndBracket+2
			Else
				PosStartBracket = -1
			End If
		End If
	Loop Until PosStartBracket = -1
	PosSearchStart = 0
ErrorLabel(ConvertHyperlinks_ERROR2)
	Do
		PosStartBracket = StrIndexOf(HtmlData,"[",PosSearchStart)
		If PosStartBracket >= 0 Then
			PosEndBracket = StrIndexOf(HtmlData,"]",PosStartBracket+1)
			If PosEndBracket >= PosStartBracket+1 Then
				If NoMarkup(PosSearchStart,PosEndBracket) = False Then
					FullLinkLength = PosEndBracket-PosStartBracket+1
					LinkPage       = SubString(HtmlData,PosStartBracket+1,PosEndBracket-PosStartBracket-1)
					If SubString(LinkPage,0,4)<>"http" Then
						Link = Main.Root&"\"&LinkPage&".txt"
					Else
						Link = LinkPage
					End If
					Link     = StrReplace(Link," ","&savedspace;")
					Link     = StrReplace(Link,"_","&savedunder;")
					Link     = StrReplace(Link,"-","&savedminus;")
					HtmlData = StrRemove(HtmlData,PosStartBracket,FullLinkLength)
					HtmlData = StrInsert(HtmlData,PosStartBracket,"<a href="&Chr(34)&Link&Chr(34)&">"&LinkPage&"</a>")
				End If
				PosSearchStart = PosEndBracket+2
			Else
				PosStartBracket = -1
			End If
		End If
	Loop Until PosStartBracket = -1
	Return
ConvertHyperlinks_ERROR1:
	HtmlData = StrInsert(HtmlData,PosEndBracket+2,"<b>MARKUP-ERROR</b>")
	Return
ConvertHyperlinks_ERROR2:
	HtmlData = StrInsert(HtmlData,PosEndBracket+1,"<b>MARKUP-ERROR</b>")
End Sub

'Convert a value with a tag
Public Sub ConvertSimpleTag(strValue,strTag)
	Dim s0, p1, p2 ,p3 ,p4
	s0 = 0
ErrorLabel(ConvertSimpleTag_ERROR)
	Do
		p1 = StrIndexOf(HtmlData,strValue ,s0)
		If p1 >= 0 Then
			p2 = StrIndexOf(HtmlData,strValue ,p1+1)
			If p2 >= p1+1 Then
				If NoMarkup(s0,p2) = False Then
					HtmlData = StrRemove(HtmlData,p2,1)
					HtmlData = StrInsert(HtmlData,p2,"</"&strTag&">")
					HtmlData = StrRemove(HtmlData,p1,1)
					HtmlData = StrInsert(HtmlData,p1,"<"&strTag&">")
				End If
				s0 = p2+1
			Else
				p1 = -1
			End If
		End If
	Loop Until p1=-1
	Return
ConvertSimpleTag_ERROR:
	HtmlData = StrInsert(HtmlData,p2+StrLength(strValue),"<b>MARKUP-ERROR</b>")
End Sub

'Convert a value with a tag
Public Sub ConvertDoubleTag(strValue1,strValue2,strTag)
	Dim p1, p2
ErrorLabel(ConvertDoubleTag_ERROR)
	Do
		p1 = StrIndexOf(HtmlData,strValue1 ,0)
		If p1 >= 0 Then
			p2 = StrIndexOf(HtmlData,strValue2 ,p1+1)
			If p2 >= p1+1 Then
				HtmlData = StrRemove(HtmlData,p2,StrLength(strValue2))
				HtmlData = StrInsert(HtmlData,p2,"</"&strTag&">")
				HtmlData = StrRemove(HtmlData,p1,StrLength(strValue1))
				HtmlData = StrInsert(HtmlData,p1,"<"&strTag&">")
			Else
				p1 = -1
			End If
		End If
	Loop Until p1=-1
	Return
ConvertDoubleTag_ERROR:
	HtmlData = StrInsert(HtmlData,p2+StrLength(strValue2),"<b>MARKUP-ERROR</b>")
End Sub

'Format a given navigation link
Public Sub ConvertNavigationLink(URL)
	If SubString(URL,0,4) = "http" Then Return URL
	If SubString(URL,0,8) = "file:///" Then URL = StrRemove(URL,0,8)
	URL = StrReplace(URL,"/","\")
	If cPPC Then URL = "\"&URL
	Return URL
End Sub

'Add a horizontal line
Public Sub ConvertLines
	If SubString(HtmlData,0,3)="___" Then
		HtmlData          = "<hr />"
		AddLineFeedToData = False
	End If
End Sub

#Region Lists
'Add a bulleted list item
Public Sub ConvertLists
	If SubString(HtmlData,0,1)="-" Then
		ProcessingList = True
		If AddListEnd = False Then
			RemoveLineFeed(TotalOutput)
			AddOutput("<ul>")
		End If
		HtmlData          = StrRemove(HtmlData,0,1)
		HtmlData          = "<li>"&HtmlData&"</li>"
		AddListEnd        = True
		AddLineFeedToData = False
	End If
End Sub
#End Region

#Region Tables
'Convert table rows
Public Sub ConvertTables
	If SubString(HtmlData,0,1)="|" Then
		ProcessingTable = True
		If CurrentLineIsTabHeader = True Then
			RemoveLineFeed(TotalOutput)
			AddOutput("<table>")
			CheckCalulations
			ConvertTableTag("|","th")
		Else
			If TableHasCalculations Then CalculateValues
			ConvertTableTag("|","td")
		End If
		CurrentLineIsTabHeader = False
		AddLineFeedToData      = False
	Else
		If CurrentLineIsTabHeader = False Then
			CurrentLineIsTabHeader = True
			AddTableEnd            = True
		End If
	End If
End Sub

Public Sub CheckCalulations
	Dim PosColumDivider, PosNextColumDivider, PosCalculations, PosDigits, ColumnString, ColumnNr
	PosColumDivider     = 0
	PosNextColumDivider = 0
	ColumnNr            = 0
	MaxColumns          = 0
	HtmlData            = StrReplace(HtmlData,"	","")	'Remove tabs
ErrorLabel(CheckCalculations_ERROR)
	Do
		If PosColumDivider < 0 Then Exit
		PosColumDivider = StrIndexOf(HtmlData,"|" ,PosColumDivider)
		If PosColumDivider >= 0 Then
			PosNextColumDivider = StrIndexOf(HtmlData,"|",PosColumDivider+1)
			If PosNextColumDivider = -1 Then PosNextColumDivider = StrLength(HtmlData)
			If PosNextColumDivider > PosColumDivider Then
				ColumnString = SubString(HtmlData,PosColumDivider+1,PosNextColumDivider-PosColumDivider-1)
				ColumnNr     = ColumnNr+1
				MaxColumns   = ColumnNr
				'Check for the number of digits after the comma and use them
				PosDigits   = StrIndexOf(ColumnString,"!",0)
				Digits(ColumnNr) = 0
				If PosDigits >= 0 Then
					Digits(ColumnNr)  = StrRemove(ColumnString,0,PosDigits+2)
					ColumnString = SubString(ColumnString,0,PosDigits)
				End If
				'Check for values and calulations
				PosCalculations = StrIndexOf(ColumnString,"=",0)
				ColumnValue(ColumnNr) = ""
				Totals(ColumnNr)      = 0
				If PosCalculations >= 0 Then
					TableHasCalculations = True
					ColumnValue(ColumnNr) = StrRemove(ColumnString,0,PosCalculations+1)
					HtmlData              = StrRemove(HtmlData,PosColumDivider+PosCalculations+1,PosNextColumDivider-(PosColumDivider+PosCalculations+1))
					PosNextColumDivider   = StrIndexOf(HtmlData,"|",PosColumDivider+1)
				End If
			End If
		Else
			Exit
		End If
		PosColumDivider = PosNextColumDivider-1
	Loop Until PosColumDivider < 0
	Return
CheckCalculations_ERROR:
End Sub

Public Sub CalculateValues
	Dim PosColumDivider, PosNextColumDivider, PosCalculations, ColumnString, ColumnNr, Calc
	A=0 : B=0 : C=0 : D=0 : E=0 : F=0 : G=0 : H=0
	PosColumDivider     = 0
	PosNextColumDivider = 0
	ColumnNr            = 0
	CalculationResult   = 0
	HtmlData            = StrReplace(HtmlData,"	","")	'Remove tabs
ErrorLabel(CalculateValues_ERROR)
	Do
		If PosColumDivider<0 OR PosColumDivider> StrLength(HtmlData) Then Exit
		PosColumDivider = StrIndexOf(HtmlData,"|" ,PosColumDivider)
		If PosColumDivider >= 0 Then
			PosNextColumDivider = StrIndexOf(HtmlData,"|",PosColumDivider+1)
			If PosNextColumDivider = -1 Then PosNextColumDivider = StrLength(HtmlData)
			If PosNextColumDivider > PosColumDivider Then
				ColumnString = SubString(HtmlData,PosColumDivider+1,PosNextColumDivider-PosColumDivider-1)
				ColumnNr     = ColumnNr+1
				If ColumnNr > MaxColumns Then Exit
				ColumnString = StrReplace(ColumnString,",",".")
				Select StrLength(ColumnValue(ColumnNr))
					Case 0		'No calculation
					Case 1		'Store a Value in a single letter variable
						Select ColumnValue(ColumnNr)
							Case "A" : If IsNumber(ColumnString) Then A=ColumnString
							Case "B" : If IsNumber(ColumnString) Then B=ColumnString
							Case "C" : If IsNumber(ColumnString) Then C=ColumnString
							Case "D" : If IsNumber(ColumnString) Then D=ColumnString
							Case "E" : If IsNumber(ColumnString) Then E=ColumnString
							Case "F" : If IsNumber(ColumnString) Then F=ColumnString
							Case "G" : If IsNumber(ColumnString) Then G=ColumnString
							Case "H" : If IsNumber(ColumnString) Then H=ColumnString
						End Select
						If IsNumber(ColumnString) Then
							Totals(ColumnNr) = Totals(ColumnNr) + ColumnString
							HtmlData = StrRemove(HtmlData,PosColumDivider+1,PosNextColumDivider-PosColumDivider-1)
							HtmlData = StrInsert(HtmlData,PosColumDivider+1,Format(ColumnString,"N"&Digits(ColumnNr)))
'							HtmlData = StrInsert(HtmlData,PosColumDivider+1,"<p class="&Chr(34)&"number"&Chr(34)&">"&Format(ColumnString,"N"&Digits(ColumnNr))&"</p>")
						End If
					Case Else	'Convert the variables into numbers and than calculate the expression
						Calc = ColumnValue(ColumnNr)
						Calc = StrReplace(Calc,"	","")	'Remove tabs
						Calc = StrReplace(Calc," ","")		'Remove spaces
						Calc = StrReplace(Calc,"A",A)
						Calc = StrReplace(Calc,"B",B)
						Calc = StrReplace(Calc,"C",C)
						Calc = StrReplace(Calc,"D",D)
						Calc = StrReplace(Calc,"E",E)
						Calc = StrReplace(Calc,"F",F)
						Calc = StrReplace(Calc,"G",G)
						Calc = StrReplace(Calc,"H",H)
						CalculationResult   = xMath.xCalc(Calc)
						Totals(ColumnNr)    = Totals(ColumnNr)+CalculationResult
						HtmlData            = StrInsert(HtmlData,PosColumDivider+1,"<b>"&Format(CalculationResult,"N"&Digits(ColumnNr))&"</b>")
						PosNextColumDivider = StrIndexOf(HtmlData,"|",PosColumDivider+1)
				End Select
			End If
		Else
			Exit
		End If
		PosColumDivider = PosNextColumDivider-1
	Loop Until PosColumDivider < 0
	Return
CalculateValues_ERROR:
End Sub

'Convert a value with a tag
Public Sub ConvertTableTag(strValue,strTag)
	Dim PosValue
	Do
		PosValue = StrIndexOf(HtmlData,strValue ,0)
		If PosValue >= 0 Then
			HtmlData = StrRemove(HtmlData,PosValue,1)
			If PosValue = 0 Then
				HtmlData = StrInsert(HtmlData,PosValue,"<"&strTag&">")
			Else
				HtmlData = StrInsert(HtmlData,PosValue,"</"&strTag&"><"&strTag&">")
			End If
		End If
	Loop Until PosValue=-1
	HtmlData = "<tr>"&HtmlData&"</"&strTag&"></tr>"
	'Add a html space character if no table-cell data is found
	HtmlData = StrReplace(HtmlData,"<"&strTag&"></"&strTag&">","<"&strTag&">&nbsp;</"&strTag&">")
End Sub

Public Sub AddTablesResultRecord
	tmpRecord = ""
	For I = 1 To MaxColumns Step 1
		If ColumnValue(I)<>"" Then
			tmpRecord = tmpRecord&"<td><b>"&Format(Totals(I),"N"&Digits(I))&"</b></td>"
		Else
			tmpRecord = tmpRecord&"<td>&nbsp;</td>"
		End If
	Next I
	AddOutput("<tr>"&tmpRecord&"</tr>")
End Sub
#End Region